#!/bin/sh
# @title HTK fast initialization
# @author Jozef Mlich

if [ -z $1 ]; then
  echo "usage $0 HMMConfig"
  exit 1
fi

. $1

if [ \( $automataComplexity -lt 1 \) -o \( $automataComplexity -gt $automataStatesCount \) ]; then 
  echo "error: automataComplexity is $automataComplexity, allowed values are between 1 and $automataStatesCount"
  exit
fi

echo 05 > $status


################################################################################
echo "creating dictionary.. ($monophones, $dictionary)"

  i=0
  echo -n "" >$monophones
  echo -n "" >$dictionary
  while [ $i -lt $classCount ]; do
    echo c$i >>$monophones
    echo c$i c$i >>$dictionary
    i=`expr $i + 1`
  done

echo 10 > $status

echo "creating model prototype.."

  allStates=`expr $automataStatesCount + 2`

  echo -n "">$prototype
  echo "  ~o <USER> <VecSize> $featureWidth">>$prototype
  echo "<BeginHMM>">>$prototype
  echo "  <NumStates> $allStates">>$prototype
  i=2
  while [ $i -lt $allStates ]; do
    echo "  <State> $i">>$prototype
    echo "    <Mean> $featureWidth">>$prototype
    echo -n "     ">>$prototype
    j=0
    while [ $j -lt $featureWidth ]; do
      echo -n " 0.0">>$prototype
      j=`expr $j + 1`
    done
    echo "">>$prototype
    echo "    <Variance> $featureWidth">>$prototype
    j=0
    echo -n "     ">>$prototype
    while [ $j -lt $featureWidth ]; do
      echo -n " 1.0">>$prototype
      j=`expr $j + 1`
    done
    echo "">>$prototype

    i=`expr $i + 1`
  done;


  echo "  <TransP> $allStates">>$prototype

  if [ $automataStatesCount -eq 1 ]; then # eg. GMM

    echo "  0.000 1.000 0.000">>$prototype
    echo "  0.000 0.500 0.500">>$prototype
    echo "  0.000 0.000 0.000">>$prototype
  else

    echo -n "  0.000 1.000">>$prototype
    i=0;
    while [ $i -lt $automataStatesCount ]; do
      echo -n " 0.000" >>$prototype
      i=`expr $i + 1`
    done
    echo "">>$prototype
    j_end=`expr $automataStatesCount + 1`
    i=0;
    while [ $i -lt $automataStatesCount ]; do
      echo -n "  0.000">>$prototype
      j=0;
      while [ $j -lt $j_end ]; do
        if [ $i -eq $j ]; then
          stCount=`expr $automataStatesCount - $j + 1`
  	  if [ $automataComplexity -gt $stCount ]; then
            transitionProbability=`echo "scale=4; 1.0/$stCount"|bc -l`
    	  else 
            transitionProbability=`echo "scale=4; 1.0/$automataComplexity"|bc -l`
  	  fi
          k=0	
	  sum=0
	  while [ \( $k -lt $automataComplexity \) -a \( $j -lt $j_end \) ]; do	  
            j=`expr $j + 1`
 	    k=`expr $k + 1`
	    if [ \( $k -eq $automataComplexity \) -o \( $j -eq $j_end \) ]; then
              transitionProbability=`echo "scale=4; 1.0000 - $sum"|bc -l`
  	      echo -n " $transitionProbability">>$prototype
	    else
              sum=`echo "scale=4; $sum + $transitionProbability"|bc -l`
  	      echo -n " $transitionProbability">>$prototype
	    fi
  	  done
          j=`expr $j - 1`
        else
          echo -n " 0.000">>$prototype
        fi
        j=`expr $j + 1`
      done
      echo "">>$prototype
      i=`expr $i + 1`
    done

    echo -n "  0.000" >>$prototype
    i=1;
    while [ $i -lt $allStates ]; do
      echo -n " 0.000" >>$prototype
      i=`expr $i + 1`
    done
    echo "">>$prototype
  fi # if [ $automataStatesCount -eq 1 ]; then # eg. !GMM
  echo "<EndHMM>">>$prototype

################################################################################

echo 20 > $status

echo "creating network.."

  echo -n "(\n  " >$network
  i=0
  while [ $i -lt $classCount ]; do
    echo -n c$i >>$network
    i=`expr $i + 1`
    if [ $i -lt $classCount ]; then 
      echo -n " | " >>$network
    fi
  done
  echo "\n)" >>$network

echo 30 > $status

  HParse $network $latice

echo 40 > $status
