#!/bin/sh
# @title HTK training
# @author Jozef Mlich

if [ -z $1 ]; then
  echo "usage $0 HMMConfig"
  exit 1
fi
      
. $1
    
################################################################################
echo "converting data to htk format/creating mlf/scripts.."

echo 50 > $status

oldIFS=$IFS
IFS="
"

  echo -n "">$trainScript
  echo -n "">$trainMLF
  echo "#!MLF!#">>$trainMLF

  for line in `cat $labelsTraining`; do

    file=`echo $line|cut -d " " -f 1`
    class=`echo $line|cut -d " " -f 2`
    destFile=$tmpData/$file
    mkdir -p `dirname $destFile`
    $txt2raw $data/$file $destFile 

    mlfSize=`stat -c%s $destFile`
    mlfSize=`expr $mlfSize / 2 \* 1250`
    echo "\"$destFile\"">>$trainMLF
    echo "0 $mlfSize c$class">>$trainMLF
    echo ".">>$trainMLF
    echo "$destFile">>$trainScript
  done
  
IFS=$oldIFS
  
################################################################################
echo "preparing models .."

echo 60 > $status

  HCompV -f 0.01 -m -S $trainScript -M $hmm1 $prototype
  
################################################################################

echo 70 > $status

echo "peparing master macro file"

  i=0
  echo -n ""> $protoMMF
  while [ $i -lt $classCount ]; do 
    cat $prototype1|sed "s/proto/c$i/">>$protoMMF
  
    i=`expr $i + 1`
  done

################################################################################
echo "training models .."

echo 80 > $status


HERest -X "txt" -I $trainMLF -t 250.0 150.0 1000.0 -S $trainScript -H $protoMMF -M $hmm2 $monophones 

################################################################################
echo "converting to Lukas's format .."

echo 90 > $status

$htk2lukas $trainMMF $hmm3

echo 95 > $status
