<?php

$argv = $_SERVER['argv'];

if (!file_exists($argv[1])) {
  die ("usage: php $argv[0] [model] [destdir]\n");
}

// nacte se soubor
$data = file_get_contents($argv[1]);

// zjisti se velikost feature vektoru
if (preg_match("/<VECSIZE>\s*(\d+)/", $data, $res)) {
  $feature_size = $res[1];
} else {
  throw new Exception("bad format");
}

// nactou se jednotlive modely
$modelsData = array();
if (preg_match_all("/~h \"\S+\"\n<BEGINHMM>/", $data, $res, PREG_OFFSET_CAPTURE)) {
  $x = $res[0];
  for ($i = 1; $i < sizeof ($x); $i++) {
    $modelsData[$i-1] = substr($data, $x[$i-1][1], $x[$i][1] - $x[$i-1][1]);
  }
  $modelsData[sizeof($modelsData)] = substr($data, $x[sizeof($x)-1][1]);

  foreach ($modelsData as $modelData) {

    if (preg_match("/~h \"(\S+)\"/", $modelData, $res)) {
      $filename = $res[1];
    } else {
      throw new Exception("bad format");  
    }

    if (preg_match("/<NUMSTATES> (\d+)/", $modelData, $res)) {
      $num_states = $res[1]-2;
    } else {
      throw new Exception("bad format");  
    }
    
    $means = "";
    
    if (preg_match_all("/<MEAN> \d+\n(.*)/", $modelData, $res)) {
      foreach ($res[1] as $line) {
        $means .= $line."\n";
      }
    } else {
      throw new Exception ("bad format");
    }
    
    $variance = "";

    if (preg_match_all("/<VARIANCE> \d+\n(.*)/", $modelData, $res)) {
      foreach ($res[1] as $line) {
        $variance .= $line."\n";
      }
    } else {
      throw new Exception ("bad format");
    }
    
    if (preg_match("/<TRANSP> \d+\n(.*)<ENDHMM>/s", $modelData, $res)) {
      $transp = $res[1];
    } else {
      throw new Exception ("bad format");
    }
    

//    print_r($modelData);
//    die ("1\n");

    $fp = fopen ($argv[2]."/$filename.model", "w");
      fwrite($fp, $num_states."\n".$feature_size."\n".$means.$variance.$transp);
    fclose($fp);
  }
  
  
} else {
  throw new Exception("bad format");
}



?>