#include <stdio.h>
#include <stdlib.h>

///////////////////////////////////////////////////////////////////////////////////

int IntSwap(int i);
short ShortSwap (short s);
float FloatSwap (float f);

///////////////////////////////////////////////////////////////////////////////////

int main (int argc, char**argv) {
  if (argc != 3) {
    printf("txt2raw <source> <dest>\n");
    return 1;
  }


  FILE *input = fopen(argv[1], "r");
  FILE *output = fopen(argv[2], "wb");
  
  if (input == NULL) {
    fprintf(stderr, "could not open input file\n");
    return 1;
  }

  if (output == NULL) {
    fprintf(stderr, "could not open output file\n");
    return 2;
  }

  int   sampPeriod = 400000 ; // 10 000 000 * 100 ns = 1s => 10 000 000 / 25 ( 25fps )
  short paramKind = 9;
  int nSamples;
  int feaVectWidth;
  short sampSize; 
  float *line;
  float tmpfloat;

  fscanf(input, "%d", &feaVectWidth);
  fscanf(input, "%d", &nSamples);
  line = (float*) malloc(sizeof(float) * feaVectWidth);
  sampSize = feaVectWidth * 4;
  
//  printf("%d %d %d %d\n", nSamples, sampPeriod, sampSize, paramKind);

  // zmena indianu
  nSamples = IntSwap(nSamples);
  sampPeriod = IntSwap(sampPeriod);
  sampSize = ShortSwap(sampSize);
  paramKind = ShortSwap(paramKind);

  // ulozeni hlavicky
  fwrite(&nSamples, sizeof(int), 1, output);
  fwrite(&sampPeriod, sizeof(int), 1, output);
  fwrite(&sampSize, sizeof(short), 1, output);
  fwrite(&paramKind, sizeof(short), 1, output);

  int i = 0;
  while (fscanf(input,"%f", &tmpfloat) != EOF) {
    tmpfloat = FloatSwap(tmpfloat);
    line[i] = tmpfloat;
    i = (i + 1) % feaVectWidth;
    if (i == 0) {
      fwrite(line, sizeof(float), feaVectWidth, output);
    }
  }

  fclose(output);
  fclose(input);

  return 0;
}

///////////////////////////////////////////////////////////////////////////////////

/**
  * Zmena indiana u floatu
  */

float FloatSwap (float f) {
  union {
    float f;
    unsigned char b[4];
  } dat1, dat2;

  dat1.f = f;
  dat2.b[0] = dat1.b[3];
  dat2.b[1] = dat1.b[2];
  dat2.b[2] = dat1.b[1];
  dat2.b[3] = dat1.b[0];
  return dat2.f;
}

/**
  * Zmena indiana u intu
  */

int IntSwap(int i) {
  union {
    int i;
    unsigned char b[4];
  } dat1, dat2;

  dat1.i = i;
  dat2.b[0] = dat1.b[3];
  dat2.b[1] = dat1.b[2];
  dat2.b[2] = dat1.b[1];
  dat2.b[3] = dat1.b[0];
  return dat2.i;
}

/**
  * Zmena indiana u shortu
  */

short ShortSwap (short s) {
  unsigned char b1, b2;
  
  b1 = s & 255;
  b2 = (s >> 8) & 255;

  return (b1 << 8) + b2;
}

